-----------------------------------------------------------------------------
-- Reduce:	Context reduction
-- 
-- Part of `Typing Haskell in Haskell', version of September 1, 1999
-- Copyright (c) Mark P Jones and the Oregon Graduate Institute
-- of Science and Technology, 1999
-- 
-- This program is distributed as Free Software under the terms
-- in the file "License" that is included in the distribution
-- of this software, copies of which may be obtained from:
--             http://www.cse.ogi.edu/~mpj/thih/
-- 
-----------------------------------------------------------------------------

module Reduce where
import Type
import Pred
import Split
import Default

reduce :: [Tyvar] -> [Tyvar] -> [Pred] -> ([Pred], [Pred])

reduce fs gs ps = (ds,rs')
 where (ds, rs) = split fs ps
       rs'      = useDefaults (fs++gs) rs

-----------------------------------------------------------------------------
